﻿/**

  The Initial Developer of the Original Code is
  Matthieu  - http://www.actionscript-facile.com
  Portions created by the Initial Developer are Copyright (C) 2010
  the Initial Developer. All Rights Reserved.

  Contributor(s) :

 */
package
{
	
	import com.google.maps.Color;
	import com.google.maps.overlays.MarkerOptions;
	import com.google.maps.overlays.Marker;
	import com.google.maps.Map;
	import com.google.maps.MapEvent;	
	import com.google.maps.services.Placemark;
	import com.google.maps.services.GeocodingEvent;
	import com.google.maps.services.ClientGeocoder;
	import com.google.maps.MapType;
	import com.google.maps.LatLng;
	import com.google.maps.MapOptions;
	
	
	import flash.geom.Point;
	import flash.net.NetworkInfo;
	import flash.desktop.NativeApplication;
	import flash.events.StatusEvent;
	import flash.events.GeolocationEvent;
	import flash.sensors.Geolocation;
	import flash.display.Sprite;
	import flash.events.Event;	
	

	import com.debug.Out;
	import com.actionscriptfacile.ui.text.UITextField;
	

	
	/**
	 * Géolocalisation d'un mobile Android avec API Flash Google Map.
	 * 
	 */
	public class MainGeolocalisation extends Sprite
	{
		private var oGeolocal : Geolocation;
		
		// clé API Google Map, à générer ici : http://code.google.com/apis/oGoogleMaps/signup.html
		private static const API_KEY : String = "ABQIAAAAUUPM2YTPbv1Mom3_EFyc_BTtbp2H4cHMNwiMGXghqrSl3NkR7xQBAD5jpCQywkbRokxaxG5SvJ5TQQ";
		
		// url du site internet (obligatoire) associé à la clé API pour utiliser  Google Map sur Android AIR
		private static const API_URL : String = "http://www.actionscript-facile.com/";
		
		private var oGoogleMap : Map;// l'objet carte google
		private var bMapReady : Boolean;// la carte google est prête ?
		private var oClientGeocoder : ClientGeocoder;// pour afficher l'adresse précise des coordonnées latitude / longitude


		
		
		/**
		 * Constructeur.
		 * 
		 */
		public function MainGeolocalisation()
		{
			// attend la fin de l'initialisation de la scène
			this.addEventListener(Event.ADDED_TO_STAGE, onReady, false, 0, true);
		}

		/**
		 * Démarrage de l'application.
		 * définit le nombre d'images par secondes dans les paramètres de compilation
		 * -default-frame-rate 40
		 * 
		 */
		private function onReady(event : Event) : void
		{
			this.removeEventListener(Event.ADDED_TO_STAGE, onReady);

			// préparation d'une sortie Trace rapide pour l'application
			var oTextDebug:UITextField = this.addText("Start Application\n");
			this.addChild(oTextDebug);
			
			Out.stage = stage;
			Out.textField = oTextDebug;
			Out.maxLength = 5333;// longueur maximum
			
			// si le mobile ne supporte pas la géolocalisation
			if( !Geolocation.isSupported )
			{
				Out.trace("Géolocalisation indisponible sur ce mobile");
				return;		
			}
			
			this.addGeolocalisation();
			
			this.addGoogleMap();
			
		}


		/**
		 * Ajout de la géolocalisation.
		 * 
		 */
		private function addGeolocalisation() : void
		{			
			// si le mobile ne supporte aucun réseau (WIFI, 3G...)
			if( !NetworkInfo.isSupported )
			{
				Out.trace("WIFI, 3G indisponibles sur ce mobile");
				return;		
			}
			
			oGeolocal = new Geolocation();
			
			// pour économiser la batterie - définit l'interval de mise à jour de géolocalisation plus espacé
			oGeolocal.setRequestedUpdateInterval(10000);// en ms - soit toutes les 10 s 
			oGeolocal.addEventListener(StatusEvent.STATUS, onGPSUpdate);
			
			// si l'utilisateur a désactivé la géolocalisation -- Paramètres ->> Localisation ->> Case à cocher Afficher ma position - Localiser au niveau
			if( oGeolocal.muted ) 
				Out.trace("Veuillez activer la géolocalisation sur votre mobile !");
				
			// pour économiser la batterie, désactivation Event de la géolocalisation lorsque l'application passe en arrière plan
			NativeApplication.nativeApplication.addEventListener(Event.ACTIVATE, onApplicationTop);// application en avant plan
			NativeApplication.nativeApplication.addEventListener(Event.DEACTIVATE, onApplicationBackground);// application en arrière plan
		}

		
		
		/**
		 * Ajout de la gestion de la carte Google Map.
		 * 
		 */
		private function addGoogleMap() : void
		{
			oGoogleMap = new Map();
			oGoogleMap.y = 300;
			oGoogleMap.key = API_KEY;
			oGoogleMap.url = API_URL;
			oGoogleMap.sensor = "false";// détection de la position via un GPS
			oGoogleMap.setSize( new Point(stage.stageWidth, stage.stageHeight - oGoogleMap.y) );// taille de la carte
			
			oGoogleMap.addEventListener(MapEvent.MAP_READY, onMapReady);
			oGoogleMap.addEventListener(MapEvent.MAP_PREINITIALIZE, onMapInit);
			//oGoogleMap.addEventListener(MapMouseEvent.CLICK, onMapClick);
			//oGoogleMap.addEventListener(MapMoveEvent.MOVE_END, onMapMoveEnd);
			
			this.addChild(oGoogleMap);
		}
		
		
		/**
		 * La carte google est prête à être utilisée.
		 * 
		 */
		private function onMapReady(event : Event) : void
		{
			Out.trace("Carte Google Map prête");
			
			oClientGeocoder = new ClientGeocoder();// pour afficher l'adresse précise des coordonnées latitude / longitude
			oClientGeocoder.addEventListener(GeocodingEvent.GEOCODING_SUCCESS, onGeocodingSuccess);
			oClientGeocoder.addEventListener(GeocodingEvent.GEOCODING_FAILURE, onGeocodingError);
			bMapReady = true;
		}
		

		/**
		 * Erreur de décodage des coordonnées latitude et longitude.
		 * 
		 */
		private function onGeocodingError(event : GeocodingEvent) : void
		{
			Out.trace("Erreur de décodage des coordonnées latitude et longitude !!!");
		}
		

		/**
		 * Coordonnées latitude et longitude décodées.
		 * 
		 */
		private function onGeocodingSuccess(event : GeocodingEvent) : void
		{
			// si l'adresse est trouvée
			if(event.response.placemarks.length > 0)
			{
				var sAdress:String = (event.response.placemarks[0] as Placemark).address;
				Out.trace("Vous êtes situé : "+sAdress);
			}
			else
				Out.trace("Adresse inexistante !!!");
			
		}
		
				
		/**
		 * Initialisation de la carte.
		 * 
		 */
		private function onMapInit(event : MapEvent) : void
		{
			var myMapOptions : MapOptions = new MapOptions();
			myMapOptions.zoom = 15;
			myMapOptions.center = new LatLng(45.779017,3.086987);// ville de Clermont Ferrand
			
			/*
			Les différents types de cartes
			NORMAL_MAP_TYPE - vue par défaut
			SATELLITE_MAP_TYPE - affiche les images satellite de Google Earth 
			HYBRID_MAP_TYPE - affiche un mixte entre le mode normal et les imagse satellites
			PHYSICAL_MAP_TYPE - affiche le relief de la terre.
			DEFAULT_MAP_TYPES - un tableau avec les différents types pour les processus itératifs.
 			*/
			myMapOptions.mapType = MapType.NORMAL_MAP_TYPE;
			
			oGoogleMap.setInitOptions(myMapOptions);
		}
		
		
		
		/**
		 * Application en arrière plan.
		 * désactive Event géolocalisation.
		 * 
		 */
		private function onApplicationBackground(event : Event) : void
		{
			Out.trace("Application en arrière plan");
			oGeolocal.removeEventListener(GeolocationEvent.UPDATE, onReceivePosition);// reçoit les mises à jour de la position de l'utilisateur
		}
		
		
		/**
		 * Application en avant plan.
		 * Active Event géolocalisation.
		 * 
		 */
		private function onApplicationTop(event : Event) : void
		{
			Out.trace("Application en avant plan");
			oGeolocal.addEventListener(GeolocationEvent.UPDATE, onReceivePosition);// reçoit les mises à jour de la position de l'utilisateur
		}


		/**
		 * L'utilisateur a activé ou désactivé la géolocalisation.
		 * 
		 */
		private function onGPSUpdate(event : StatusEvent) : void
		{
			var oGeolocalis:Geolocation = event.target as Geolocation;// récupère l'objet Geolocation
			
			// si l'utilisateur a désactivé la géolocalisation -- Paramètres ->> Localisation ->> Case à cocher Afficher ma position - Localiser au niveau
			if( oGeolocalis.muted ) 
				Out.trace("Géolocalisation désactivée. Veuillez activer la géolocalisation !");
			else
				Out.trace("Géolocalisation activée sur votre mobile.");
		}
	
		
		/**
		 * Réception de la position du mobile.
		 * latitude et longitude.
		 * 
		 */
		private function onReceivePosition(event : GeolocationEvent) : void
		{
			/**
			 * latitude entre -90 et 90 degrés
			 * longitude entre 180 et -180 degrés
			 * altitude en mètres
			 * speed en mètre / seconde : pour calculer la vitesse de déplacement
			 * 
			 * heading - pointage vers le nord - un angle par rapport au nord et à l'utilisateur (0° au nord)
			 * - non supporté par tous les mobiles
			 */
			Out.trace("Latitude : "+mathRounding(event.latitude, 3)+" ## longitude : "+mathRounding(event.longitude,3)+
			" ## altitude : "+mathRounding(event.altitude) );
			
			// si la carte google est prêt
			if( bMapReady )
			{
				// affiche la position du mobile sur la carte
				var oLatitudeLongitude:LatLng = new LatLng(event.latitude, event.longitude);
				
				// coordonnées de la zone - niveau de zoom - le type de carte (satellite...)
				oGoogleMap.setCenter(oLatitudeLongitude, 16, MapType.HYBRID_MAP_TYPE);
				
				// trouve l'adresse précise correspondant aux coordonnées latitude et longitude
				oClientGeocoder.reverseGeocode( oLatitudeLongitude );
				
				// ajoute un bouton de navigation
				var oMarkerOptions:MarkerOptions = new MarkerOptions
				({
					fillStyle:{color:Color.GREEN,alpha: 0.8},
					hasShadow: true,
					radius: 12,
					clickable: false,
					draggable: true,
					tooltip: "Vous êtes ici"
				});
				
				var oMarker : Marker = new Marker(oLatitudeLongitude, oMarkerOptions);
				oGoogleMap.addOverlay( oMarker );
			}
		}
		
	
		
		/**
		 * Création d'un champ texte.
		 * 
		 */
		private function addText(sValue:String) : UITextField
		{
			var oTxtField:UITextField = new UITextField();
			oTxtField.text = sValue;
		
			oTxtField.alignLeft(); // centre le texte
			oTxtField.convertToDynamic(); // centre le texte
			oTxtField.border = true;
			
			oTxtField.maxWidth = oTxtField.width = 433;
			oTxtField.maxHeight = oTxtField.height = 300;
			
			oTxtField.changeFormat("size", 12);// changement de la taille de la police du texte
			oTxtField.changeFormat("font", "Arial");// changement de la taille de la police du texte
			oTxtField.changeFormat("color", 0x006f77);// changement de la couleur
			
			return oTxtField;
		}
		
		
		/**
		 * Arrondi un nombre à x décimales après la virgule.
		 * 
		 * @param nValue : nombre à arrondir
		 * @param nDecimal : nombre de décimal (par défaut pas arrondi sans décimal)
		 * @return : nombre arrondi
		 */
		private function mathRounding( nValue:Number, nDecimal:int=0) : Number
		{
			// Math.pow pour la puissance de 10 - puissance de 10 en fonction du nombre de décimal
			var nMult:Number = Math.pow(10, nDecimal); 
			
			return Math.round( nValue * nMult ) / nMult;
		}
	}
}
